server_address = EConfiguration.get_full_main_server_address
server_address += '/' if server_address[-1,1] != '/'

xml.instruct!
xml.feed('xmlns' => 'http://www.w3.org/2005/Atom', 'xmlns:package'=>'http://schemas.asperasoft.com/xml/package', 'xml:lang' => 'en') do
  xml.title(feed_name, 'type' => 'text')
  rel = lambda{ |link_box| (link_box == box ? 'self' : link_box)}
  xml.link('type' => 'application/atom+xml', 'rel' => rel.call('inbox'), 'href' => "#{server_address}inbox.atom")
  xml.link('type' => 'application/atom+xml', 'rel' => rel.call('archive'), 'href' => "#{server_address}archive.atom")
  xml.link('type' => 'application/atom+xml', 'rel' => rel.call('sent'), 'href' => "#{server_address}sent.atom")

  count = params[:count].to_i || 10

  if params[:startIndex].present?
    startIndex = params[:startIndex].to_i

    xml.link('type' => 'application/atom+xml', 'rel' => 'next', 'href' => "#{server_address}#{box}?count=#{count}&startIndex=#{startIndex + count}")
    xml.link('type' => 'application/atom+xml', 'rel' => 'previous', 'href' => "#{server_address}#{box}?count=#{count}&startIndex=#{[0, startIndex - count].max}") if (startIndex > 0)
  else
    xml.link('type' => 'application/atom+xml', 'rel' => 'next', 'href' => "#{server_address}#{box}?page=#{page + 1}&count=#{count}") if has_next_page?(@deliveries)
    xml.link('type' => 'application/atom+xml', 'rel' => 'previous', 'href' => "#{server_address}#{box}?page=#{page - 1}&count=#{count}") if (page > 1)
  end
  # We list deliveries in a strange order! This is for backward compatibility
  # Newest to oldest as page number increases, but oldest to newest on a single
  # page!
  @deliveries.reverse.each do |d|
    @delivery = d
    xml << render(:partial => 'delivery/entry')
  end
end
